# Yahoo! UI Library

### datatable 3.3.0

Yahoo! UI Library > datatable > Columnset
Search:
Filters Show Private Show Protected Show Deprecated

## Class Columnset - extends Base

The Columnset class defines and manages a collection of Columns.

### Constructor

Columnset `( )`

### Properties

#### idHash - `Object`

Hash of all Columns by ID.

#### keyHash - `Object`

Hash of all Columns by key.

#### keys - `Y.Column[]`

Array of only Columns that are meant to be displayed in DOM.

#### NAME - `static final String`

Class name.

#### tree - `Y.Column[]`

Top-down tree representation of Column hierarchy. Used to create DOM elements.

#### Properties inherited from Plugin.Host:

`PluginHost`

#### Properties inherited from Attribute:

``

#### Properties inherited from Base:

`name`

### Methods

#### _cascadePropertiesToChildren

`private void _cascadePropertiesToChildren ( )`
Cascade certain properties to children if not defined on their own.

#### _setColSpans

`private void _setColSpans ( column , definition )`
Calculates and sets colSpan attribute on given Column.

Parameters:
  `column <Array>` Column instance.
  `definition <Object>` Column definition.

#### _setDefinitions

`private void _setDefinitions ( definitions )`
Clones definitions before setting.

Parameters:
  `definitions <Array>` Array of column definitions.

#### _setHeaders

`private void _setHeaders ( )`
Calculates and sets headers attribute on all Columns.

#### _setRowSpans

`private void _setRowSpans ( )`
Calculates and sets rowSpan attribute on all Columns.

#### destructor

`private void destructor ( )`
Destructor.

#### initializer

`private void initializer ( config )`
Initializer. Generates all internal representations of the collection of Columns.

Parameters:
  `config <Object>` Config object.

#### Methods inherited from EventTarget:

`_getType, _monitor, _parseType, addTarget, after, before, bubble, detach, detachAll, fire, getEvent, getTargets, on, once, parseType, publish, removeTarget, subscribe, unsubscribe, unsubscribeAll`

#### Methods inherited from Attribute:

`_addAttrs, _addLazyAttr, _defAttrChangeFn, _fireAttrChange, _getAttr, _getAttrCfg, _getAttrInitVal, _getAttrs, _getStateVal, _isLazyAttr, _normAttrVals, _protectAttrs, _set, _setAttr, _setAttrs, _setAttrVal, _setStateVal, addAttr, addAttrs, attrAdded, get, getAttrs, modifyAttr, removeAttr, reset, set, setAttrs`

#### Methods inherited from Plugin.Host:

`_destroyPlugins, _initPlugins, hasPlugin, plug, unplug`

#### Methods inherited from Base:

`_aggregateAttrs, _defDestroyFn, _defInitFn, _destroyHierarchy, _filterAttrCfs, _getAttrCfgs, _getClasses, _initHierarchy, _initHierarchyData, _preInitEventCfg, destroy, init, toString`

### Events

#### definitionsChange

`definitionsChange ( event )`
Fires when the value for the configuration attribute 'definitions' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### Events inherited from Base:

`destroy, destroyedChange, init, initializedChange,`

### Configuration Attributes

#### definitions `- Array`

Array of column definitions that will populate this Columnset.

#### Configuration attributes inherited from Base:

`destroyed initialized`

Copyright © 2011 Yahoo! Inc. All rights reserved.